# rtds_calender.rb by Ys
#
# Original Code is.......
# Created: March 26,1999 Friday 14:55:05
# Author: tetsu(WATANABE Tetsuya)
# $Id: rtds_calender.rb,v 1.1.1.1 2002/05/18 09:28:28 kazane Exp $

require 'cgi-lib'

class TCalendar
  def initialize(y,m)
    @holiday = []
    @mday_arr = []
    1.upto(31) do |d|
      @mday_arr[d] = Time.local(y.to_i, m.to_i, d, 0, 0, 0)
      if d > 28
        if @mday_arr[d].month != m
          @mday_arr[d] = nil
        end
      end
    end
    @month_name = @mday_arr[1].strftime('%B')
  end

  def nMonday(n)
    count = 0
    @mday_arr.each_index do |d|
      next if d < 1
      count += 1 if @mday_arr[d].wday == 1
      return d if count == n
    end
  end

  def wday(mday)
    return nil unless @mday_arr[mday]
    @mday_arr[mday].wday
  end

  def status(mday)
    return nil unless @mday_arr[mday]
    case @mday_arr[mday].wday
    when 1, 2, 3, 4, 5
      'workday'
    when 0
      'holiday'
	when 6
	  'weekend'
    end
  end

  def header
    msg = "<table class=\"calender\">\n" ##{@mday_arr[1].strftime('%B %Y')}
    msg + "<tr><th>Sun</th><th>Mon</th><th>Tue</th><th>Wed</th><th>Thu</th><th>Fri</th><th>Sat</th></tr>\n"
  end
end

def cal_add_tag(status,d)
	case status
	    when 'holiday'
	      CGI::tag("td", {"class"=>"holiday"}) {
	      format('%2d', d)
	    }
	    when 'weekend'
	      CGI::tag("td", {"class"=>"weekend"}) {
	      format('%2d', d)
	    }
	    when 'workday'
	      CGI::tag("td") {
	      format('%2d', d)
		}
		when 'other'
	      CGI::tag("td", {"class"=>"other_file"}) {
	      format('%2d', d)
	    }
	end
end


def main
	cal = TCalendar.new(@year,@month)
	msg = cal.header

	1.upto(31) do |d|
	  wday = cal.wday(d)
	  break unless wday

	  status = cal.status(d)

	  if (d == 1)
	    msg.concat('<td></td>' * wday)
	  elsif wday == 0
	    msg.concat("</tr>\n")
	  end

	  day_str =
		case @day_sufix
			when "a"
				if d < 16
					cal_add_tag(status,d)
				else
					cal_add_tag('other',d)
				end
			when "b"
				if d > 15
					cal_add_tag(status,d)
				else
					cal_add_tag('other',d)
				end
		end

	    msg.concat(day_str)
	end
	return(msg)
end

def cal_sub_msg(msg)
	@cal_search_str = @day_tr.to_i.to_s
	if @cal_search_str =~ /./
		msg.sub!("> #{@cal_search_str}<","><a href=\"#d#{@year}#{@month}#{@day_tr}\"> #{@cal_search_str}</a><")
	else
		msg.sub!(">#{@cal_search_str}<","><a href=\"#d#{@year}#{@month}#{@day_tr}\">#{@cal_search_str}</a><")
	end
end

def rtds_calender
	begin
		msg = open("#{@plugin_files}/#{@year}#{@month}#{@day_sufix}.calender","r").read
		cal_sub_msg(msg)
	rescue
		msg = main
		msg.gsub!(/^<td/,"<tr><td")
		cal_sub_msg(msg)
		msg << "</tr>\n</table>\n"
	ensure
		open("#{@plugin_files}/#{@year}#{@month}#{@day_sufix}.calender","w").write msg
		#print "#{msg}\n</table>\n"
		return(msg)
	end
end
